import React from 'react';
import { UseFieldApiConfig } from '@data-driven-forms/react-form-renderer';
import useFieldApi from '@data-driven-forms/react-form-renderer/use-field-api';
import { v4 as uuidv4 } from 'uuid';
import {
  FileUploader as MagmaFileUploader,
  FileUploaderProps as MagmaFileUploaderProps,
} from '@react-magma/file-uploader';

export type FileUploaderProps = MagmaFileUploaderProps & UseFieldApiConfig;

const FileUploaderMapping = (props: FileUploaderProps) => {
  const {
    input,
    validateOnMount,
    showError,
    ...rest
  } = useFieldApi(props);
  const id = input.name || uuidv4();

  return (
    <MagmaFileUploader
      {...input}
      id={id}
      // errorMessage={errorMessage}
      {...rest}
    />
  );
};

export const FileUploader = React.memo(FileUploaderMapping);
